'-------------------------------------------------------------------------------
' Alexey Shvarev         \\             hard&soft
' Olga Matushkina-Gerke  \\  -    soft
'
' Nixie Clock
' sunny_clock.BAS
'
' the ds1307 clock on the M8
'
' 2009
'-------------------------------------------------------------------------------
$regfile = "m8def.dat"
$crystal = 8000000
'$baud = 57600
$lib "mcsbyte.lbx"                                          ' for smaller code
$lib "ds1307clock.lib"                                      ' modified lib
'-------------------------------------------------------------------------------
Config Portd.6 = Output                                     ' PortD.6 = DC_HI_0
Config Portd.7 = Output                                     ' PortD.7 = DC_HI_1
Config Portb.0 = Output                                     ' PortB.0 = DC_HI_2
Config Portb.1 = Output                                     ' PortB.1 = DC_HI_3

Config Portb.7 = Output                                     ' PortB.7 = DC_LO_0
Config Portd.3 = Output                                     ' PortD.3 = DC_LO_1
Config Portd.2 = Output                                     ' PortD.2 = DC_LO_2
Config Portb.6 = Output                                     ' PortB.6 = DC_LO_3

Config Portc.0 = Output                                     ' PortC.0 = TUB_14
Config Portc.1 = Output                                     ' PortC.1 = TUB_25
Config Portc.2 = Output                                     ' PortC.2 = TUB_36

Config Portb.2 = Output                                     ' PortB.2 = NC
Config Portc.3 = Output                                     ' PortC.3 = DP_LO
Config Portd.4 = Output                                     ' PortD.4 = DP_HI
Config Portd.5 = Output                                     ' PortD.5 = BEEP

'-------------------------------------------------------------------------------
Dc_hi.0 Alias Portd.6
Dc_hi.1 Alias Portd.7
Dc_hi.2 Alias Portb.0
Dc_hi.3 Alias Portb.1

Dc_lo.0 Alias Portb.7
Dc_lo.1 Alias Portd.3
Dc_lo.2 Alias Portd.2
Dc_lo.3 Alias Portb.6

Tube_14 Alias Portc.0
Tube_25 Alias Portc.1
Tube_36 Alias Portc.2

Dp_hi Alias Portd.4                                         ' 0 -   T4,T5,T6 
Dp_lo Alias Portc.3                                         ' 0 -   T1,T2,T3 
Beep Alias Portd.5                                          ' 0 -  

'-------------------------------------------------------------------------------
'Config Com1 = 57600 , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
Config Adc = Single , Prescaler = Auto , Reference = Avcc   '  

'-------------------------------------------------------------------------------
'configure the scl and sda pins
Config Sda = Portc.4
Config Scl = Portc.5

'address of ds1307
Const Ds1307w = &HD0                                        ' Addresses of Ds1307 clock
Const Ds1307r = &HD1

Config Clock = User                                         ' this will dim the bytes automatic
Config Date = Mdy , Separator = /
'-------------------------------------------------------------------------------

Dim First_start As Byte                                     ' "1" -   
Dim Weekday As Byte

Dim Dc_tube As String * 4                                   '   ()   
Dim Dc_b(4) As Byte                                         '   ()   
Dim Q$ As String * 1                                        '  

Dim Tube_time$ As String * 8                                '   
Dim Tube_date$ As String * 8                                '   
Dim See_time$ As String * 8                                 '   
Dim Tube_time_5$ As String * 5                              '  

Dim 1sec_year As String * 1                                 '  /
Dim 10sec_year As String * 1                                '  /
Dim 1min_month As String * 1                                '  /
Dim 10min_month As String * 1                               '  /
Dim 1hour_day As String * 1                                 '  /
Dim 10hour_day As String * 1                                '  /

Dim Mday As Byte                                            ' MAX    

Dim Set_digit$ As String * 2                                '  , 2  ( )
Dim Set_digit As Byte                                       '  , ( )

Dim Tube$(6) As String * 1                                  '   i- 

Dim Cur_sec As Byte                                         '  _sec

Dim Set_mode As Byte                                        ' : =1     , <>1   

Dim Zero_leader As Byte                                     ' : =1 -  1-  
Dim Date_in_time As Byte                                    ' : =1 -    57  59 

Dim Mode_work As Byte                                       '   

Dim Return_min As Byte                                      '     , 

Dim Bright As Byte                                          ' "1..6" -   
Dim Bright_set As Byte                                      ' "1..6" -     

Dim Tb_off As Bit                                           '     (   )

Dim T14 As Bit                                              '  : =0 -   1  4   HV
Dim T25 As Bit                                              '  : =0 -   2  5   HV
Dim T36 As Bit                                              '  : =0 -   3  6   HV

Dim T_flash(6) As Byte                                      ' : T_flash(i)=1,  T(i)  
Dim T_off(12) As Byte                                       ' : T_off(i)=1 - T(1..6) ; T(7..12) 
Dim T_down(6) As Byte                                       ' : T_down(i)=1 - T(i)   
Dim T_bright(6) As Byte                                     ' : T_bright(i)=1 - T(i)    

Dim T_dp(6) As Byte                                         ' : T_dp(6)=1 - DP () T(i)   ,    

Dim Tube_on As Byte                                         ' "1" -   
Dim Dp_on As Bit                                            ' "1" -    

Dim N_bright As Byte                                        '   ,         
Dim Flash_on As Integer                                     '         1 

Dim F_alarm(2) As Byte                                      '  =1   

Dim Time_alarm$(2) As String * 8                            ' ,     1
Dim Tube_alarm$(2) As String * 5                            '       

Dim Alarm_min$ As String * 2                                '  
Dim Alarm_hour$ As String * 2                               '  
Dim Alarm_n$ As String * 1                                  '  
Dim N_alarm As Byte                                         '    (1,2)
Dim Alarm_on As Byte                                        ' : Alarm_on=1 -   
Dim Beep_on As Byte                                         ' : Beep_on=1 -  ,    

Dim Key As Byte                                             ' ,    
Dim Volum_key As Word                                       '  ,   
Dim Key_adc As Byte                                         ' ""  
Dim Key_summ As Byte                                        '     
Dim Key_temp As Byte                                        '     
                                                             '   
                                                             ' 0 -   
                                                             ' 1 -   1
                                                             ' 2 -   2
                                                             ' 21 -   1
                                                             ' 22 -   2

Dim I As Byte                                               '  
Dim A As Byte                                               '  
Dim N As Integer                                            '      1 
Dim K As Byte                                               '   

Declare Sub Translit(xr As String , Xi As String )          '      
'-------------------------------------------------------------------------------

$eeprom
$eepromhex

Data_1:
 Data 4
Data_2:
 Data 0                                                     '  
Data_3:
 Data 0                                                     '  
Data_4:
 Data "07:15:01"                                            '    7  15   1 
Data_5:
 Data "07:30:02"                                            '    7  30   2 
Data_6:
 Data 1                                                     ' 

$data
'-------------------------------------------------------------------------------
Gosub Init
Gosub Flash_down_init
'-------------------------------------------------------------------------------

Do

  Tube_time$ = Time$                                        '       
  Tube_date$ = Date$
  See_time$ = Tube_time$
  Tube_time_5$ = Mid(see_time$ , 1 , 5)                     ' ,    (   )

 Gosub Tube_display                                         '      

  If Return_min = 0 Then                                    '     ,    
   Mode_work = 0
   Return_min = 2
   Gosub Flash_down_init                                    '   / 
  End If

  If Key <> 0 Then                                          '     -    
   Return_min = 2                                           '    
  End If

  Select Case Mode_work                                     '      
   Case 40 : Gosub Set_bright
   Case 99 : Gosub Alarm
   Case 32 : Gosub Set_hour_alarm
   Case 31 : Gosub Set_min_alarm
   Case 30 : Gosub Set_alarm
   Case 22 : Gosub Set_day
   Case 21 : Gosub Set_month
   Case 20 : Gosub Set_year
   Case 12 : Gosub Set_hour
   Case 11 : Gosub Set_min
   Case 10 : Gosub Set_sec
   Case Else Gosub See_time                                 '   
 End Select

 Beep_on = Alarm_on And Tube_on                             '       
 Beep = Beep_on

 If Cur_sec <> _sec Then                                    '     
  If Cur_sec = 0 Then                                       '    :
   Return_min = Return_min - 1                              '   1     
   For I = 1 To 2                                           '     ?
    Tube_alarm$(i) = Mid(time_alarm$(i) , 1 , 5)            '
    If Tube_time_5$ = Tube_alarm$(i) Then
     Alarm_on = F_alarm(i)                                  '* 2
     Gosub Flash_down_init
     Mode_work = 99                                         '   -       
     Return_min = 2                                         '   
    End If
   Next I
  End If
                                                             '  
  N_bright = 0
  Tb_off = 1
  Cur_sec = _sec
  Flash_on = N \ 2
  N = 0                                                     '     
 End If

  If N_bright = 4 Then                                      '    
   N_bright = 0                                             '   
   Tb_off = 0
  Else
   N_bright = N_bright + 1
   Tb_off = 1
  End If

 If N >= Flash_on Then                                      '     1
  Tube_on = 0                                               '   
  Dp_on = 1
 Else
  Tube_on = 1
  Dp_on = 0
 End If

'----------------------------------
Gosub Setdc_tube14                                          '
T14 = T_off(1) And T_off(4)                                 '   1  4 ,   
Tube_14 = T14                                               '   1  4  
Gosub Tube_on_off
'----------------------------------
Gosub Setdc_tube36
T36 = T_off(3) And T_off(6)
Tube_36 = T36
Gosub Tube_on_off
'----------------------------------
Gosub Setdc_tube25
T25 = T_off(2) And T_off(5)
Tube_25 = T25
Gosub Tube_on_off
'----------------------------------
Gosub Analiz_key
N = N + 1

 Loop Until K = 1
End
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Tube_on_off:                                                '  - 
                                                             '      
 Select Case Bright                                         '   
'  Case 1 :                                                '   -  
  Case 1 : Waitus 1
  Case 2 : Waitus 50
  Case 3 : Waitus 150
  Case 4 : Waitus 350
  Case 5 : Waitus 500
  Case 6 : Waitus 800
'  Case 7 : Waitus 1000
 End Select
'  Waitus 800

  Tube_14 = 1                                               '     
  Tube_25 = 1
  Tube_36 = 1

 Volum_key = Getadc(6)                                      '      
 Select Case Volum_key
  Case 470 To 550 : Key_adc = 3
  Case 600 To 800 : Key_adc = 1
  Case Else : Key_adc = 0
 End Select

  Key_summ = Key_summ + Key_adc                             ' 
'--------------------------------------
For A = 1 To 6

   '      
   T_off(a) = Tube_on And T_flash(a)
   T_off(a + 6) = Tb_off And T_bright(a)
   T_off(a) = T_off(a) Or T_off(a + 6)
   T_off(a) = T_off(a) Or T_down(a)

Next A
'----------------------------------------
'  Waitus 600
'  Waitus 500
  Waitus 400                                                '  


  Dc_lo.0 = 1                                               '   
  Dc_lo.1 = 1
  Dc_lo.2 = 1
  Dc_lo.3 = 1
  Dc_hi.0 = 1
  Dc_hi.1 = 1
  Dc_hi.2 = 1
  Dc_hi.3 = 1

  Dp_lo = 0
  Dp_hi = 0

Return
'-------------------------------------------------------------------------------
'   

'called from ds1307clock.lib

Getdatetime:
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 0                                                ' start address in 1307

  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307r                                          ' send address
  I2crbyte _sec , Ack
  I2crbyte _min , Ack                                       ' MINUTES
  I2crbyte _hour , Ack                                      ' Hours
  I2crbyte Weekday , Ack                                    ' Day of Week
  I2crbyte _day , Ack                                       ' Day of Month
  I2crbyte _month , Ack                                     ' Month of Year
  I2crbyte _year , Nack                                     ' Year
  I2cstop
  _sec = Makedec(_sec) : _min = Makedec(_min) : _hour = Makedec(_hour)
  _day = Makedec(_day) : _month = Makedec(_month) : _year = Makedec(_year)
Return

Setdate:
  _day = Makebcd(_day) : _month = Makebcd(_month) : _year = Makebcd(_year)
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 4                                                ' starting address in 1307
  I2cwbyte _day                                             ' Send Data to SECONDS
  I2cwbyte _month                                           ' MINUTES
  I2cwbyte _year                                            ' Hours
  I2cstop
Return

Settime:
  _sec = Makebcd(_sec) : _min = Makebcd(_min) : _hour = Makebcd(_hour)
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 0                                                ' starting address in 1307
  I2cwbyte _sec                                             ' Send Data to SECONDS
  I2cwbyte _min                                             ' MINUTES
  I2cwbyte _hour                                            ' Hours
  I2cstop
Return
'-------------------------------------------------------------------------------
'        
Sub Translit(xr As String , Xi As String )
 Dim W As Byte
 W = Val(xi)
 Select Case W
   Case 0 : Xr = "0000"
   Case 1 : Xr = "0001"
   Case 2 : Xr = "0010"
   Case 3 : Xr = "0011"
   Case 4 : Xr = "0100"
   Case 5 : Xr = "0101"
   Case 6 : Xr = "0110"
   Case 7 : Xr = "0111"
   Case 8 : Xr = "1000"
   Case 9 : Xr = "1001"
   Case Else Xr = "1111"
 End Select
End Sub
'-------------------------------------------------------------------------------
Setdc_tube36:                                               '      6  3

'   T6
 If T_off(6) = 0 Then
  Call Translit(dc_tube , Tube$(6) )                        '       
  Dp_lo = T_dp(6)                                           '     6
  Gosub Set_dc_lo
 End If

'   T3
 If T_off(3) = 0 Then
  Call Translit(dc_tube , Tube$(3) )
  Dp_hi = T_dp(3)
  Gosub Set_dc_hi
 End If

Return
'-------------------------------------------------------------------------------
Setdc_tube25:

 '   T5
 If T_off(5) = 0 Then
  Call Translit(dc_tube , Tube$(5) )
  Dp_lo = T_dp(5)
  Gosub Set_dc_lo
 End If

 '   T2
 If T_off(2) = 0 Then
  Call Translit(dc_tube , Tube$(2) )
  Dp_hi = T_dp(2)
  Gosub Set_dc_hi
 End If

Return
'-------------------------------------------------------------------------------
Setdc_tube14:

 '   T4
 If T_off(4) = 0 Then
  Call Translit(dc_tube , Tube$(4) )
  Dp_lo = T_dp(4)
  Gosub Set_dc_lo
 End If

 '   T1
 If T_off(1) = 0 Then
  Call Translit(dc_tube , Tube$(1) )
  Dp_hi = T_dp(1)
  Gosub Set_dc_hi
 End If

Return
'-------------------------------------------------------------------------------
Set_dc_lo:
  For I = 1 To 4 Step 1
    Q$ = Mid(dc_tube , I , 1)                               '    
    Dc_b(i) = Val(q$)                                       '  
  Next I
  Dc_lo.0 = Dc_b(4)                                         '    LO  
  Dc_lo.1 = Dc_b(3)
  Dc_lo.2 = Dc_b(2)
  Dc_lo.3 = Dc_b(1)
Return
'-------------------------------------------------------------------------------
Set_dc_hi:
  For I = 1 To 4 Step 1
    Q$ = Mid(dc_tube , I , 1)
    Dc_b(i) = Val(q$)
  Next I
  Dc_hi.0 = Dc_b(4)                                         '    HI  
  Dc_hi.1 = Dc_b(3)
  Dc_hi.2 = Dc_b(2)
  Dc_hi.3 = Dc_b(1)
Return
'-------------------------------------------------------------------------------

Init:                                                       '    

Readeeprom Bright_set , Data_1
Readeeprom F_alarm(1) , Data_2
Readeeprom F_alarm(2) , Data_3
Readeeprom Time_alarm$(1) , Data_4
Readeeprom Time_alarm$(2) , Data_5
Readeeprom First_start , Data_6

 If First_start <> 0 Then                                   '       
  Time$ = "00:45:00"                                        '
  Date$ = "10/11/09"
  First_start = 0
  Writeeeprom First_start , Data_6
 End If

  Readeeprom First_start , Data_6

 Bright = Bright_set                                        '     
 Key_temp = 0
 Key_summ = 0
 Key_temp = 0
 Key = 0
 K = 0
 N = 0
 Zero_leader = 1
 Date_in_time = 1
 Flash_on = 10000
 Beep_on = 0
 Tube_on = 0
 Set_mode = 0
 Return_min = 0

 Start Adc                                                  '  

Return
'-------------------------------------------------------------------------------
Flash_down_init:                                            '    ,   ..  

For I = 1 To 6
 T_flash(i) = 0
 T_down(i) = 0
 T_bright(i) = 0
 T_dp(i) = 0
Next I

Return
'-------------------------------------------------------------------------------
Tube_time:                                                  '     

1sec_year = Mid(tube_time$ , 8 , 1)
10sec_year = Mid(tube_time$ , 7 , 1)
1min_month = Mid(tube_time$ , 5 , 1)
10min_month = Mid(tube_time$ , 4 , 1)
1hour_day = Mid(tube_time$ , 2 , 1)
10hour_day = Mid(tube_time$ , 1 , 1)

Return
'-------------------------------------------------------------------------------
Tube_date:                                                  '     

1hour_day = Mid(tube_date$ , 5 , 1)
10hour_day = Mid(tube_date$ , 4 , 1)
1min_month = Mid(tube_date$ , 2 , 1)
10min_month = Mid(tube_date$ , 1 , 1)
1sec_year = Mid(tube_date$ , 8 , 1)
10sec_year = Mid(tube_date$ , 7 , 1)

Return
'-------------------------------------------------------------------------------
Tube_display:                                               ' ,     

Tube$(1) = 10hour_day
Tube$(2) = 1hour_day
Tube$(3) = 10min_month
Tube$(4) = 1min_month
Tube$(5) = 10sec_year
Tube$(6) = 1sec_year

 If Mode_work = 10 Then                                     '         
  If Zero_leader = 0 Then
   If 10hour_day = "0" Then
   T_down(1) = 1
    If 1hour_day = "0" Then
    T_down(2) = 1
    Else
    T_down(2) = 0
    End If
   Else
   T_down(1) = 0
   End If
  End If
 End If
Return
'-------------------------------------------------------------------------------
Analiz_key:
                                                              '   
  Select Case Key_summ
     Case 0 : Key_temp = 0
     Case 3 : Key_temp = 1
     Case 9 : Key_temp = 2
  End Select
Key_summ = 0
'----------------------
  If Key = 1 Then                                           '       
   If Key_temp = 2 Then
   Key = 2
   End If
  End If

  If Key = 21 Then                                          '   ,
  Key = 0                                                   '    
  End If
  If Key = 22 Then
  Key = 0
  End If

 If Key_temp = 0 Then
  If Key = 0 Then
   Goto End_analiz
  Else
    If Key = 1 Then                                         '     
    Key = 21                                                '    
    End If
    If Key = 2 Then
    Key = 22
    End If
   Goto End_analiz
  End If
 Else
  If Key = 0 Then
  Key = Key_temp
  End If
 End If
End_analiz:
Return
'-------------------------------------------------------------------------------
Alarm:                                                      ' mode_work=99
                                                            '    
 T_dp(5) = F_alarm(1)
 T_dp(6) = F_alarm(2)
    If Key = 22 Then                                        '  .2 -   
     Return_min = 0
     Key = 0
    End If
 Gosub Tube_time

Return
'-------------------------------------------------------------------------------
See_time:                                                   ' mode_work=00
                                                            '   (   )
 Alarm_on = 0                                               '   
 T_dp(5) = F_alarm(1)
 T_dp(6) = F_alarm(2)

 If Key = 2 Then                                            '  .2 -  
  Gosub Tube_date                                           '  -   
  Goto Date_end
 End If

 If Key = 22 Then
  Gosub Tube_date
  Goto Date_end
  End If

 If _sec <= 57 Then                                         '  57-   
  Gosub Tube_time
 Else
   If Date_in_time = 1 Then
    Gosub Tube_date
   Else
    Gosub Tube_time
   End If
 End If

Date_end:

   If Key = 21 Then                                         '  .1 ->    10
     Mode_work = 10
     Key = 0
     Set_mode = 1
   End If

Return
'-------------------------------------------------------------------------------
Set_sec:                                                    '  10 (mode_work=10)
                                                            '  
  If Set_mode = 1 Then                                      '       
    T_flash(5) = 1                                          '    
    T_flash(6) = 1
    Set_mode = 0
  End If                                                    '    
 Gosub Tube_time

 If Key = 2 Then                                            '    2 -  
  _sec = 0                                                  '      
  Gosub Settime
  Cur_sec = 0
 End If

 If Key = 22 Then
  T_flash(5) = 0
  T_flash(6) = 0
  Key = 0
  Mode_work = 0
 End If

 If Key = 21 Then                                           '  .1 ->    11
  Mode_work = 11
  T_flash(5) = 0
  T_flash(6) = 0
  Key = 0
  Set_mode = 1
 End If

Return
'-------------------------------------------------------------------------------
Set_min:                                                    ' mode_work=11

  If Set_mode = 1 Then                                      '  
    Bright = 4
    T_bright(1) = 1                                         '   
    T_bright(2) = 1
    T_bright(5) = 1
    T_bright(6) = 1
    Set_mode = 0                                            '  
    Set_digit = _min
  End If
                                                            '    
   If Set_digit < 10 Then
    Set_digit$ = Str(set_digit)
    Set_digit$ = "0" + Set_digit$
   Else
    Set_digit$ = Str(set_digit)
   End If

  1sec_year = Mid(tube_time$ , 8 , 1)                       '      
  10sec_year = Mid(tube_time$ , 7 , 1)                      '  
  1min_month = Mid(set_digit$ , 2 , 1)
  10min_month = Mid(set_digit$ , 1 , 1)
  1hour_day = Mid(tube_time$ , 2 , 1)
  10hour_day = Mid(tube_time$ , 1 , 1)

  If Key = 22 Then                                          '   .2  
   Incr Set_digit
    If Set_digit = 60 Then
    Set_digit = 0
    End If
  End If

 If Key = 21 Then                                           '   .1 
  Gosub Flash_down_init                                     '      12
  If _min <> Set_digit Then
   _min = Set_digit
   Gosub Settime
  End If

  Mode_work = 12
  Key = 0
  Set_mode = 1
 End If

Return
'-------------------------------------------------------------------------------
Set_hour:                                                   ' mode_work=12
                                                            '  
  If Set_mode = 1 Then
    T_bright(3) = 1
    T_bright(4) = 1
    T_bright(5) = 1
    T_bright(6) = 1
    Set_mode = 0
    Set_digit = _hour
  End If

   If Set_digit < 10 Then
    Set_digit$ = Str(set_digit)
    Set_digit$ = "0" + Set_digit$
   Else
    Set_digit$ = Str(set_digit)
   End If

  1sec_year = Mid(tube_time$ , 8 , 1)
  10sec_year = Mid(tube_time$ , 7 , 1)
  1min_month = Mid(tube_time$ , 5 , 1)
  10min_month = Mid(tube_time$ , 4 , 1)
  1hour_day = Mid(set_digit$ , 2 , 1)
  10hour_day = Mid(set_digit$ , 1 , 1)

  If Key = 22 Then
   Incr Set_digit
    If Set_digit = 24 Then
    Set_digit = 0
    End If
  End If

 If Key = 21 Then

  Gosub Flash_down_init
  If _hour <> Set_digit Then
   _hour = Set_digit
   Gosub Settime
  End If

  Mode_work = 20
  Key = 0
  Set_mode = 1
 End If

Return
'-------------------------------------------------------------------------------
Set_year:                                                   ' mode_work=20
                                                            '  
  If Set_mode = 1 Then
    T_bright(1) = 1
    T_bright(2) = 1
    T_bright(3) = 1
    T_bright(4) = 1
    Dp_on(5) = 1
    Dp_on(6) = 1
    Set_mode = 0
    Set_digit = _year
  End If

   If Set_digit < 10 Then
    Set_digit$ = Str(set_digit)
    Set_digit$ = "0" + Set_digit$
   Else
    Set_digit$ = Str(set_digit)
   End If

  1sec_year = Mid(set_digit$ , 2 , 1)
  10sec_year = Mid(set_digit$ , 1 , 1)
  1min_month = Mid(tube_date$ , 2 , 1)
  10min_month = Mid(tube_date$ , 1 , 1)
  1hour_day = Mid(tube_date$ , 5 , 1)
  10hour_day = Mid(tube_date$ , 4 , 1)

  If Key = 22 Then
   Incr Set_digit
    If Set_digit = 41 Then
    Set_digit = 8
    End If
  End If

 If Key = 21 Then
  _year = Set_digit
  Gosub Setdate
  Mode_work = 21
  Key = 0
  Set_mode = 1
  Gosub Flash_down_init
 End If

Return
'-------------------------------------------------------------------------------
Set_month:                                                  ' mode_work=21
                                                            '  
  If Set_mode = 1 Then
    T_bright(1) = 1
    T_bright(2) = 1
    T_bright(5) = 1
    T_bright(6) = 1
    Dp_on(3) = 1
    Dp_on(4) = 1
    Set_mode = 0
    Set_digit = _month
  End If

   If Set_digit < 10 Then
    Set_digit$ = Str(set_digit)
    Set_digit$ = "0" + Set_digit$
   Else
    Set_digit$ = Str(set_digit)
   End If
'---------------------------------------
  1sec_year = Mid(tube_date$ , 8 , 1)
  10sec_year = Mid(tube_date$ , 7 , 1)
  1min_month = Mid(set_digit$ , 2 , 1)
  10min_month = Mid(set_digit$ , 1 , 1)
'  1hour_day = Mid(tube_date$ , 5 , 1)
'  10hour_day = Mid(tube_date$ , 4 , 1)
'---------------------------------------
  If Key = 22 Then
   Incr Set_digit
    If Set_digit = 13 Then
    Set_digit = 1
    End If
  End If

 If Key = 21 Then
  _month = Set_digit
  Gosub Setdate
  Mode_work = 22
  Key = 0
  Set_mode = 1
  Gosub Flash_down_init
 End If

Return
'-------------------------------------------------------------------------------
Set_day:                                                    ' mode_work=22
                                                            '   
  If Set_mode = 1 Then
    T_bright(3) = 1
    T_bright(4) = 1
    T_bright(5) = 1
    T_bright(6) = 1
    Dp_on(1) = 1
    Dp_on(2) = 1
    Set_mode = 0
    Set_digit = _day
  End If

   If Set_digit < 10 Then
    Set_digit$ = Str(set_digit)
    Set_digit$ = "0" + Set_digit$
   Else
    Set_digit$ = Str(set_digit)
   End If

  1sec_year = Mid(tube_date$ , 8 , 1)
  10sec_year = Mid(tube_date$ , 7 , 1)
  1min_month = Mid(tube_date$ , 2 , 1)
  10min_month = Mid(tube_date$ , 1 , 1)
  1hour_day = Mid(set_digit$ , 2 , 1)
  10hour_day = Mid(set_digit$ , 1 , 1)

 If Key = 22 Then
  Incr Set_digit
   If Set_digit > 28 Then                                   '     
     Select Case _month                                     '    
        Case 1
           Mday = 31
        Case 2
           Mday = _year And &H03
           If Mday = 0 Then
              Mday = 29
           Else
              Mday = 28
           End If
        Case 3
           Mday = 31
        Case 4
           Mday = 30
        Case 5
           Mday = 31
        Case 6
           Mday = 30
        Case 7
           Mday = 31
        Case 8
           Mday = 31
        Case 9
           Mday = 30
        Case 10
           Mday = 31
        Case 11
           Mday = 30
        Case 12
           Mday = 31
     End Select
     If Set_digit > Mday Then
        Set_digit = 1
     End If
   End If
 End If

 If Key = 21 Then
  _day = Set_digit
  Gosub Setdate
  Mode_work = 30
  Key = 0
  Set_mode = 1
  N_alarm = 1
  Gosub Flash_down_init
 End If

Return
'-------------------------------------------------------------------------------
Tube_alarm:

    Tube_time$ = Time_alarm$(n_alarm)
    Gosub Tube_time
    Alarm_min$ = Mid(tube_time$ , 4 , 2)
    Alarm_hour$ = Mid(tube_time$ , 1 , 2)
    Alarm_n$ = Mid(tube_time$ , 8 , 1 )

Return
'-------------------------------------------------------------------------------
Set_alarm:                                                  ' mode_work=30
                                                            '   
  If Set_mode = 1 Then
    Gosub Tube_alarm                                        '  1..4  , .5 
    T_bright(1) = 1                                         '   6 -  
    T_bright(2) = 1
    T_bright(3) = 1
    T_bright(4) = 1
    T_down(5) = 1
    T_dp(6) = F_alarm(n_alarm)
    Set_mode = 0
  End If

  If Key = 22 Then                                          ' .2 -     n_alarm (1,2)
   F_alarm(n_alarm) = Not F_alarm(n_alarm)
   T_dp(6) = F_alarm(n_alarm)
  End If

 If Key = 21 Then
   Mode_work = 31
   Key = 0
   Set_mode = 1
   Gosub Flash_down_init
   T_down(5) = 1
 End If

 Return
'-------------------------------------------------------------------------------
Set_min_alarm:                                              ' mode_work=31
                                                            '   
  If Set_mode = 1 Then
    T_bright(1) = 1
    T_bright(2) = 1
    T_bright(5) = 1
    T_bright(6) = 1
    T_down(5) = 1
    Set_mode = 0
    T_dp(6) = F_alarm(n_alarm)
    Set_digit = Val(alarm_min$)
  End If

   If Set_digit < 10 Then
    Set_digit$ = Str(set_digit)
    Set_digit$ = "0" + Set_digit$
   Else
    Set_digit$ = Str(set_digit)
   End If

   1sec_year = Mid(time_alarm$(n_alarm) , 8 , 1)
   1min_month = Mid(set_digit$ , 2 , 1)
   10min_month = Mid(set_digit$ , 1 , 1)
   1hour_day = Mid(time_alarm$(n_alarm) , 2 , 1)
   10hour_day = Mid(time_alarm$(n_alarm) , 1 , 1)

  If Key = 22 Then
   Set_digit = Set_digit + 5                                '   5 
    If Set_digit >= 60 Then
    Set_digit = 0
    End If
  End If

 If Key = 21 Then
   Time_alarm$(n_alarm) = Alarm_hour$ + ":" + Set_digit$ + ":0" + Alarm_n$
   Set_mode = 1
   Mode_work = 32
   Gosub Flash_down_init
   T_down(5) = 1
 End If

Return
'-------------------------------------------------------------------------------
Set_hour_alarm:                                             ' mode_work=32
                                                            '   
  If Set_mode = 1 Then
    Gosub Tube_alarm                                        '   
    T_bright(3) = 1                                         '    -  
    T_bright(4) = 1
    T_bright(5) = 1
    T_bright(6) = 1
    T_down(5) = 1
    T_dp(6) = F_alarm(n_alarm)

    Set_mode = 0
    Set_digit = Val(alarm_hour$)
  End If

   If Set_digit < 10 Then
    Set_digit$ = Str(set_digit)
    Set_digit$ = "0" + Set_digit$
   Else
    Set_digit$ = Str(set_digit)
   End If

  1sec_year = Mid(time_alarm$(n_alarm) , 8 , 1)
  1min_month = Mid(time_alarm$(n_alarm) , 5 , 1)
  10min_month = Mid(time_alarm$(n_alarm) , 4 , 1)
  1hour_day = Mid(set_digit$ , 2 , 1)
  10hour_day = Mid(set_digit$ , 1 , 1)

  If Key = 22 Then
   Incr Set_digit
    If Set_digit >= 24 Then
    Set_digit = 0
    End If
  End If

 If Key = 21 Then
   Time_alarm$(n_alarm) = Set_digit$ + ":" + Alarm_min$ + ":0" + Alarm_n$
   Tube_alarm$(n_alarm) = Mid(time_alarm$(n_alarm) , 1 , 5)
   Set_mode = 1
   N_alarm = N_alarm + 1
    If N_alarm >= 3 Then
     Writeeeprom F_alarm(1) , Data_2
     Writeeeprom F_alarm(2) , Data_3
     Writeeeprom Time_alarm$(1) , Data_4
     Writeeeprom Time_alarm$(2) , Data_5
     Mode_work = 40
     Set_mode = 1
     Gosub Flash_down_init
    Else
     Mode_work = 30                                         '    2- 
     Gosub Flash_down_init
     T_down(5) = 1
    End If
 End If

Return
'-------------------------------------------------------------------------------
Set_bright:                                                 ' mode_work=40
                                                            '     
  If Set_mode = 1 Then
    Bright = Bright_set                                     '   
     For A = 1 To 6                                         '     
     T_dp(a) = 1
     Next A
    Set_mode = 0
  End If

  Gosub Tube_time

  If Key = 22 Then                                          '  .2 -  +1 [1..6]
    Bright = Bright + 1
     If Bright = 7 Then
       Bright = 1
     End If
  End If

 If Key = 21 Then                                           '  .1 - ,    
  Bright_set = Bright

  Writeeeprom Bright_set , Data_1
  Mode_work = 00
  Key = 0
  Set_mode = 1
  Gosub Flash_down_init
 End If

Return
'-------------------------------------------------------------------------------